#ifndef __NFC_H__
#define __NFC_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef WIN32
#include <windows.h>
#endif

#ifdef __linux__
#include <unistd.h>
#endif

#include <winscard.h>

#ifndef FALSE
  #define FALSE 0
#endif
#ifndef TRUE
  #define TRUE 1
#endif

#include "nfc_tag.h"
#include "nfc_tag_smartposter.h"
#include "nfc_ndef.h"
#include "nfc_rtd_uri.h"
#include "nfc_rtd_text.h"
#include "nfc_card.h"
#include "nfc_utils.h"

void nfc_list_readers(void);
char *nfc_reader_find(char *reader_name);
BOOL nfc_reader_is_card_present(char *reader_name);
BOOL nfc_reader_wait_card_present(char *reader_name);
BOOL nfc_reader_wait_card_absent(char *reader_name);


#define NDEF_MESSAGE_TAG              0x03
#define TERMINATOR_MESSAGE_TAG        0xFE

#define MAX_NFC_TAG_SIZE 128*1024

extern BOOL nfc_verbose;
extern BOOL nfc_silent;

#endif
