#ifndef __NFC_CARD_H__
#define __NFC_CARD_H__

typedef struct _nfc_card_st *nfc_card_t;

#define CARD_INNOVISION_TOPAZ  0x10
#define CARD_NXP_MIFARE_UL     0x20
#define CARD_NXP_MIFARE_UL_C   0x21
#define CARD_NXP_MIFARE_1K     0x22
#define CARD_NXP_MIFARE_4K     0x23
#define CARD_NXP_DESFIRE_EV1   0x40

nfc_card_t nfc_card_open(char *reader_name);
void nfc_card_close(nfc_card_t card);
BOOL nfc_card_recognize(nfc_card_t card);
int  nfc_card_get_type(nfc_card_t card);
size_t nfc_card_get_capacity(nfc_card_t card);
BOOL nfc_card_is_prepared(nfc_card_t card);
BOOL nfc_card_is_writable(nfc_card_t card);
BOOL nfc_card_is_empty(nfc_card_t card);
BOOL nfc_card_prepare(nfc_card_t card);
BOOL nfc_card_write_ndef(nfc_card_t card, unsigned char *ndef_buffer, size_t ndef_size);
BOOL nfc_card_lock(nfc_card_t card);

#endif

