using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.Win32;
using System.Collections.ObjectModel;


namespace NFCTool
{
  public partial class OpenUrlFrm : Form
  {
    string mainUrl;
    public bool alwaysOpen = false;
    public OpenUrlFrm(string url, bool bMaximized)
    {
      InitializeComponent();
      mainUrl = url;
      labelUrl.Text += mainUrl + " ?";
    }

    [System.Runtime.InteropServices.DllImportAttribute("shell32.dll", SetLastError = true)]
    static extern int ShellExecute(int hwnd, string lpOperation, string lpFile, string lpParameters, string lpDirectory, int nShowCmd);
    
    public void RunUrl(string sUrl, bool bMaximized)
    {
      ShellExecute(0, "open", sUrl, string.Empty, string.Empty, (bMaximized == true) ? 3 : 1);
    }

    private void butYes_Click(object sender, EventArgs e)
    {
      RunUrl(mainUrl, true);
      RegisterConfig();
      this.Close();
      this.Dispose();
    }

    // Saving current config into registry 
    private void RegisterConfig()
    {
      try
      {

        RegistryKey RecordKey =
        Registry.LocalMachine.CreateSubKey("SOFTWARE\\SpringCard\\NFCTool");

        if (cBAlwaysYes.Checked)
        {
          RecordKey.SetValue("AlwaysOpen", "1");
        }
        else
        {
          RecordKey.DeleteValue("AlwaysOpen", false);
        }
      }
      catch (Exception)
      {
        // cannot write registry
      }

    }

    public void ReadRegister()
    {
      // settings according to config registered
      try
      {
        RegistryKey confKey =
         Registry.LocalMachine.OpenSubKey("SOFTWARE\\SpringCard\\NFCTool");
        string[] ConfkeyNames = confKey.GetValueNames();
        foreach (string key in ConfkeyNames)
        {

          // setting former Reader name 
          if (key.Contains("AlwaysOpen"))
          {
            alwaysOpen = true;
          }

        }
      }
      catch (Exception)
      {
        // do nothing, the key doesn't exist in register
      }
    }

    private void butNo_Click(object sender, EventArgs e)
    {
      this.Close();
      this.Dispose();
    }


  }
}