using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using SpringCardPCSC;
using Microsoft.Win32;
using System.Collections.ObjectModel;

namespace NFC_Decoder
{
  public partial class ConfigReaderForm : Form
  {
     // settings chosen by user
    public string ReaderName = "";
    private bool canClose = true;
    public bool connect = false;

    public NFCDecoderFrm parentWnd;

    public ConfigReaderForm(NFCDecoderFrm CallingWindow, bool Closable)
    {
      InitializeComponent();
      canClose = Closable;
      buttonOK.DialogResult = DialogResult.OK;
      // reader Name ComboBox filled with list loaded with SPCSC.getListReaders

      for (int i = 0; i < SCARD.Readers.Length; i++)
        ReadercomboBox.Items.Add(SCARD.Readers[i]);

      if (ReadercomboBox.Items.Count > 0)
      {
        ReadercomboBox.SelectedItem = 0;
      }

      ReadRegister();

      checkBoxAuto.Checked = connect;

      this.parentWnd = CallingWindow;
    }

    private void ReaderComboBox_SelectedIndexChanged(object sender, EventArgs e)
    {
      this.ReaderName = ReadercomboBox.SelectedItem.ToString();
    }


    public void ReadRegister()
    {
      // settings according to config registered
      try
      {
        RegistryKey confKey =
         Registry.CurrentUser.OpenSubKey("SOFTWARE\\SpringCard\\NFCTool");
        string[] ConfkeyNames = confKey.GetValueNames();
        foreach (string key in ConfkeyNames)
        {
          // setting former Reader name 
          if (key.Contains("Reader"))
          {
            if (ReadercomboBox.Items.Contains(confKey.GetValue(key)))
            {
              ReadercomboBox.SelectedItem = confKey.GetValue(key);
              ReaderName = confKey.GetValue(key).ToString();
            }

          }

          // setting former Reader name 
          if (key.Contains("AutoConnect"))
          {
            connect = true;
          }

        }
      }
      catch (Exception)
      {
        // do nothing, the key doesn't exist in register
      }
      /*
      if( (connect) && (ReaderName != "") )
      {
        this.parentWnd.SetReader(ReaderName);
        this.Close();
        this.Dispose();
      }*/
    }

    private void butOk_Click(object sender, EventArgs e)
    {
      this.parentWnd.SetReader(this.ReaderName);
      RegisterConfig();
      this.Close();
      this.Dispose();
    }

    private void buttonReload_Click(object sender, EventArgs e)
    {
      // re load readers' list
      // erase former list
      ReadercomboBox.Items.Clear();
      for (int i = 0; i < SCARD.Readers.Length; i++)
        ReadercomboBox.Items.Add(SCARD.Readers[i]);
      if (ReadercomboBox.Items.Count > 0)
        ReadercomboBox.SelectedIndex = 0;
    }

    // Saving current config into registry 
    private void RegisterConfig()
    {
      RegistryKey RecordKey =
        Registry.CurrentUser.CreateSubKey("SOFTWARE\\SpringCard\\NFCTool");

      // register reader values
      RecordKey.SetValue("Reader", ReaderName);

      if (checkBoxAuto.Checked)
      {
        RecordKey.SetValue("AutoConnect", "1");
      }
      else
      {
        RecordKey.DeleteValue("AutoConnect",false);
      }

    }

    private void ReaderconfigForm_FormClosing(object sender, FormClosingEventArgs e)
    {
      if (this.DialogResult != DialogResult.OK && canClose)
      {
        // close everything in case the form wasn't closed by "OK" button
        parentWnd.Close();
        parentWnd.Dispose();
      }
    }

  }
}

