using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using SpringCardPCSC;
using System.Runtime.InteropServices;

namespace SCardTK
{
  public partial class ApduParametersForm : Form
  {
    private string CLA = "";
    private string INS = "";
    private string P1 = "";
    private string P2 = "";
    private string LC = "";
    private string DATAIN = "";
    private string LE = "";
    private string RawApdu = "";
    private int DataInLength;
    private SCardTKForm parent;
    char[] limit = { ';' };
    char[] desc = { ':' };
    string sectionName;

#region initialize form
    public ApduParametersForm(string ApduCmdStr, SCardTKForm parentFrm,CAPDU lastApdu)
    {
      InitializeComponent();
      parent = parentFrm;
      char[] limitChoices = {','};
      char[] toRemove = { '{', '}' };
      char[] defaultVal = { '/'};
      string[] ApduBytes = ApduCmdStr.Split(limit);
      this.Text += ApduBytes[0];
      if (ApduBytes[1].StartsWith("X"))
      {
        textBoxForCla.Visible = true;
        string[] defaultValueArr = ApduBytes[1].Split(defaultVal);
        if (defaultValueArr.Length > 1)
          textBoxForCla.Text = defaultValueArr[1];
        if (lastApdu != null)
          textBoxForCla.Text = String.Format("{0:X02}",lastApdu.CLA);
      }
      else
      {
        if (ApduBytes[1].StartsWith("{"))
        {
          string[] defaultValueArr = ApduBytes[1].Split(defaultVal);
          string ListChoices = defaultValueArr[0].Trim(toRemove);
          string[] choices = ListChoices.Split(limitChoices);
          for (int i = 0; i < choices.Length; i++)
            comboBoxForCla.Items.Add(choices[i]);
          comboBoxForCla.Visible = true;
          
          if (defaultValueArr.Length > 1)
            comboBoxForCla.SelectedItem = defaultValueArr[1];
          if (lastApdu != null)
            comboBoxForCla.SelectedItem = String.Format("{0:X02}", lastApdu.CLA);
        }else
        {
          labelForCla.Text = ApduBytes[1];
          labelForCla.Visible = true;
          if(ApduBytes[1] != "-")
            CLA = ApduBytes[1];
        }
      }

      if (ApduBytes[2].StartsWith("X"))
      {
        textBoxForIns.Visible = true;
        string[] defaultValueArr = ApduBytes[2].Split(defaultVal);
        if (defaultValueArr.Length > 1)
          textBoxForIns.Text = defaultValueArr[1];
        if (lastApdu != null)
          textBoxForCla.Text = String.Format("{0:X02}", lastApdu.INS);
        
      }
      else
      {
        if (ApduBytes[2].StartsWith("{"))
        {
          string[] defaultValueArr = ApduBytes[2].Split(defaultVal);
          string ListChoices = defaultValueArr[0].Trim(toRemove);
          string[] choices = ListChoices.Split(limitChoices);
          for (int i = 0; i < choices.Length; i++)
            comboBoxForIns.Items.Add(choices[i]);
          comboBoxForIns.Visible = true;
          
          if (defaultValueArr.Length > 1)
            comboBoxForIns.SelectedItem = defaultValueArr[1];
          if (lastApdu != null)
            comboBoxForIns.SelectedItem = String.Format("{0:X02}", lastApdu.CLA);
        }else
        {
          labelForIns.Text = ApduBytes[2];
          labelForIns.Visible = true;
          if (ApduBytes[2] != "-")
            INS = ApduBytes[2];
        }
      }

      if (ApduBytes[3].StartsWith("X"))
      {
        textBoxForP1.Visible = true;
        string[] defaultValueArr = ApduBytes[3].Split(defaultVal);
        if (defaultValueArr.Length > 1)
          textBoxForP1.Text = defaultValueArr[1];
        if (lastApdu != null)
          textBoxForP1.Text = String.Format("{0:X02}", lastApdu.P1);
      }
      else
      {
        if (ApduBytes[3].StartsWith("{"))
        {
          string[] defaultValueArr = ApduBytes[3].Split(defaultVal);
          string ListChoices = defaultValueArr[0].Trim(toRemove);
          string[] choices = ListChoices.Split(limitChoices);
          for (int i = 0; i < choices.Length; i++)
            comboBoxForP1.Items.Add(choices[i]);
          comboBoxForP1.Visible = true;
          
          if (defaultValueArr.Length > 1)
            comboBoxForP1.SelectedItem = defaultValueArr[1];
          if (lastApdu != null)
            comboBoxForP1.SelectedItem = String.Format("{0:X02}", lastApdu.P1);
        }else
        {
          labelForP1.Text = ApduBytes[3];
          labelForP1.Visible = true;
          if (ApduBytes[3] != "-")
            P1 = ApduBytes[3];
        }
      }

      if (ApduBytes[4].StartsWith("X") )
      {
        textBoxForP2.Visible = true;
        string[] defaultValueArr = ApduBytes[4].Split(defaultVal);
        if (defaultValueArr.Length > 1)
          textBoxForP2.Text = defaultValueArr[1];
        if (lastApdu != null)
          textBoxForP2.Text = String.Format("{0:X02}", lastApdu.P2);
      }else
      {
        if(ApduBytes[4].StartsWith("{"))
        {
          string[] defaultValueArr = ApduBytes[4].Split(defaultVal);
          string ListChoices = defaultValueArr[0].Trim(toRemove);
          string[]choices = ListChoices.Split(limitChoices);
          for(int i= 0; i<choices.Length;i++)
            comboBoxForP2.Items.Add(choices[i]);
          comboBoxForP2.Visible = true;
          
          if (defaultValueArr.Length > 1)
            comboBoxForP2.SelectedItem = defaultValueArr[1];
          if (lastApdu != null)
            comboBoxForP2.SelectedItem = String.Format("{0:X02}", lastApdu.P2);
        }else
        {
          labelForP2.Text = ApduBytes[4];
          labelForP2.Visible = true;
          if (ApduBytes[4] != "-")
            P2 = ApduBytes[4];
        }
      }

      if (ApduBytes[5].StartsWith("X"))
      {
        textBoxForLc.Visible = true;
        string[] defaultValueArr = ApduBytes[5].Split(defaultVal);
        if (defaultValueArr.Length > 1)
          textBoxForLc.Text = defaultValueArr[1];
        if (lastApdu != null)
          textBoxForLc.Text = String.Format("{0:X02}", lastApdu.Lc);
      }
      else
      {
        if (ApduBytes[5].StartsWith("{"))
        {
          string[] defaultValueArr = ApduBytes[5].Split(defaultVal);
          string ListChoices = defaultValueArr[0].Trim(toRemove);
          string[] choices = ListChoices.Split(limitChoices);
          for (int i = 0; i < choices.Length; i++)
            comboBoxForLc.Items.Add(choices[i]);
          comboBoxForLc.Visible = true;
          
          if (defaultValueArr.Length > 1)
            comboBoxForLc.SelectedItem = defaultValueArr[1];
          if (lastApdu != null)
            comboBoxForLc.SelectedItem = String.Format("{0:X02}", lastApdu.Lc);
        }else
        {
          labelForLc.Text = ApduBytes[5];
          labelForLc.Visible = true;
          if (ApduBytes[5] != "-")
          {
            LC = ApduBytes[5];
            DataInLength = (int)System.Convert.ToByte(int.Parse(LC,
          System.Globalization.NumberStyles.HexNumber));
          }
        }
      }

      if ( (ApduBytes[6].StartsWith("X")) ||
         (LC != "") && (ApduBytes[6].Length < DataInLength*2 ))
      {
        textBoxForDataIn.Visible = true;
        textBoxForDataIn.Text = ApduBytes[6].Replace("X","");
        textBoxForDataIn.SelectionStart = textBoxForDataIn.Text.Length;
        string[] defaultValueArr = ApduBytes[6].Split(defaultVal);
        if (defaultValueArr.Length > 1)
          textBoxForDataIn.Text = defaultValueArr[1];
        if (lastApdu != null)
          textBoxForDataIn.Text = createStrFromByteArray(lastApdu.data.Bytes);
      }
      else
      {
        if (ApduBytes[6].StartsWith("{"))
        {
          string[] defaultValueArr = ApduBytes[6].Split(defaultVal);
          string ListChoices = defaultValueArr[0].Trim(toRemove);
          string[] choices = ListChoices.Split(limitChoices);
          for (int i = 0; i < choices.Length; i++)
            comboBoxForDataIn.Items.Add(choices[i]);
          comboBoxForDataIn.Visible = true;
          
          if (defaultValueArr.Length > 1)
            comboBoxForDataIn.SelectedItem = defaultValueArr[1];

          if (lastApdu != null)
            comboBoxForDataIn.SelectedItem = createStrFromByteArray(lastApdu.data.Bytes);
        }else
        {
          labelForDataIn.Text = ApduBytes[6];
          labelForDataIn.Visible = true;
          if (ApduBytes[6] != "-")
            DATAIN = ApduBytes[6];
        }
      }

      if (ApduBytes[7].StartsWith("X"))
      {
        textBoxForLe.Visible = true;
        string[] defaultValueArr = ApduBytes[7].Split(defaultVal);
        if (defaultValueArr.Length > 1)
          textBoxForLe.Text = defaultValueArr[1];
        if (lastApdu != null)
          textBoxForLe.Text = String.Format("{0:X02}", lastApdu.Le);
      }
      else
      {
        if (ApduBytes[7].StartsWith("{"))
        {
          string[] defaultValueArr = ApduBytes[7].Split(defaultVal);
          string ListChoices = defaultValueArr[0].Trim(toRemove);
          string[] choices = ListChoices.Split(limitChoices);
          for (int i = 0; i < choices.Length; i++)
            comboBoxForLe.Items.Add(choices[i]);
          comboBoxForLe.Visible = true;
          
          if (defaultValueArr.Length > 1)
            comboBoxForLe.SelectedItem = defaultValueArr[1];
          if (lastApdu != null)
            comboBoxForLe.SelectedItem = String.Format("{0:X02}", lastApdu.Le);
        }else
        {
          labelForLe.Text = ApduBytes[7];
          labelForLe.Visible = true;
          if (!ApduBytes[7].StartsWith("-"))
            LE = ApduBytes[7];
        }
      }

      sectionName = CLA+INS;
      if (sectionName.Length == 4)
      {
        string desc_temp = IniReadValue(sectionName, "P1");
        string[] desc_array = desc_temp.Split(limit);
        DescriptionP1.Text = desc_array[0];
        
        if (comboBoxForP1.SelectedItem != null)
        {
          P1 = comboBoxForP1.SelectedItem.ToString();
          if (desc_array.Length > 1)
          {
            for (int cpt = 1; cpt < desc_array.Length; cpt++)
            {
              if (desc_array[cpt].StartsWith(P1 + ":"))
              {
                string[] choice_array = desc_array[cpt].Split(desc);
                if (choice_array.Length > 1)
                  DescriptionP1.Text += " : " + choice_array[1];
              }
            }
          }
        }
        if (DescriptionP1.Text.Length > 0)
          DescriptionP1.Visible = true;


        desc_temp = IniReadValue(sectionName, "P2");
        desc_array = desc_temp.Split(limit);
        DescriptionP2.Text = desc_array[0];
        
        if (comboBoxForP2.SelectedItem != null)
        {
          P2 = comboBoxForP2.SelectedItem.ToString();
          if (desc_array.Length > 1)
          {
            for (int cpt = 1; cpt < desc_array.Length; cpt++)
            {
              if (desc_array[cpt].StartsWith(P2 + ":"))
              {
                string[] choice_array = desc_array[cpt].Split(desc);
                if (choice_array.Length > 1)
                  DescriptionP2.Text += " : " + choice_array[1];
              }
            }
          }
        }
        if (DescriptionP2.Text.Length > 0)
          DescriptionP2.Visible = true;

        string P1P2str = P1 + P2;
        desc_temp = IniReadValue(sectionName, "P1P2");
        if (desc_temp != "")
        {
          desc_array = desc_temp.Split(limit);
          DescriptionP1.Text = desc_array[0];

          if (desc_array.Length > 1)
          {
            for (int cpt = 1; cpt < desc_array.Length; cpt++)
            {
              if (desc_array[cpt].StartsWith(P1P2str + ":"))
              {
                string[] choice_array = desc_array[cpt].Split(desc);
                if (choice_array.Length > 1)
                  DescriptionP1.Text += " : " + choice_array[1];
              }
            }
          }
        }
        if (DescriptionP1.Text.Length > 0)
          DescriptionP1.Visible = true;

        desc_temp = IniReadValue(sectionName, "DataIn");
        desc_array = desc_temp.Split(limit);
        DescriptionDataIn.Text = desc_array[0];
        if (DescriptionDataIn.Text.Length > 0)
          DescriptionDataIn.Visible = true;
      }


    }
#endregion

#region get values from combo boxes
    private void comboBoxForCla_SelectedIndexChanged(object sender, EventArgs e)
    {
      CLA = comboBoxForCla.SelectedItem.ToString();
    }

    private void comboBoxForIns_SelectedIndexChanged(object sender, EventArgs e)
    {
      INS = comboBoxForIns.SelectedItem.ToString();
    }

    private void comboBoxForP1_SelectedIndexChanged(object sender, EventArgs e)
    {
      P1 = comboBoxForP1.SelectedItem.ToString();
      string desc_temp = IniReadValue(sectionName, "P1");
      string[] desc_array = desc_temp.Split(limit);
      DescriptionP1.Text = desc_array[0];
      
      if (desc_array.Length > 1)
      {
        for (int cpt = 1; cpt < desc_array.Length; cpt++)
        {
          if(desc_array[cpt].StartsWith(P1+":"))
          {
            string[] choice_array = desc_array[cpt].Split(desc);
            if(choice_array.Length>1)
              DescriptionP1.Text += " : "+choice_array[1];
          }
        }
      }
      if (DescriptionP1.Text.Length > 0)
        DescriptionP1.Visible = true;

      string P1P2str = P1 + P2;
      desc_temp = IniReadValue(sectionName, "P1P2");
      if (desc_temp != "")
      {
        desc_array = desc_temp.Split(limit);
        DescriptionP1.Text = desc_array[0];

        if (desc_array.Length > 1)
        {
          for (int cpt = 1; cpt < desc_array.Length; cpt++)
          {
            if (desc_array[cpt].StartsWith(P1P2str + ":"))
            {
              string[] choice_array = desc_array[cpt].Split(desc);
              if (choice_array.Length > 1)
                DescriptionP1.Text += " : " + choice_array[1];
            }
          }
        }
      }
      if (DescriptionP1.Text.Length > 0)
        DescriptionP1.Visible = true;

    }

    private void comboBoxForP2_SelectedIndexChanged(object sender, EventArgs e)
    {
      P2 = comboBoxForP2.SelectedItem.ToString();
      string desc_temp = IniReadValue(sectionName, "P2");
      string[] desc_array = desc_temp.Split(limit);
      DescriptionP2.Text = desc_array[0];
      
      if (desc_array.Length > 1)
      {
        for (int cpt = 1; cpt < desc_array.Length; cpt++)
        {
          if (desc_array[cpt].StartsWith(P2 + ":"))
          {
            string[] choice_array = desc_array[cpt].Split(desc);
            if (choice_array.Length > 1)
              DescriptionP2.Text += " : " + choice_array[1];
          }
        }
      }

      if (DescriptionP2.Text.Length > 0)
        DescriptionP2.Visible = true;

      string P1P2str = P1 + P2;
      desc_temp = IniReadValue(sectionName, "P1P2");
      if (desc_temp != "")
      {
        desc_array = desc_temp.Split(limit);
        DescriptionP1.Text = desc_array[0];

        if (desc_array.Length > 1)
        {
          for (int cpt = 1; cpt < desc_array.Length; cpt++)
          {
            if (desc_array[cpt].StartsWith(P1P2str + ":"))
            {
              string[] choice_array = desc_array[cpt].Split(desc);
              if (choice_array.Length > 1)
                DescriptionP1.Text += " : " + choice_array[1];
            }
          }
        }
      }
      if (DescriptionP1.Text.Length > 0)
        DescriptionP1.Visible = true;
    }

    private void comboBoxForLc_SelectedIndexChanged(object sender, EventArgs e)
    {
      LC = comboBoxForLc.SelectedItem.ToString();
    }

    private void comboBoxForDataIn_SelectedIndexChanged(object sender, EventArgs e)
    {
      DATAIN = comboBoxForDataIn.SelectedItem.ToString();
    }

    private void comboBoxForLe_SelectedIndexChanged(object sender, EventArgs e)
    {
      LE = comboBoxForLe.SelectedItem.ToString();
    }

#endregion

#region close form

    private void buttonCancel_Click(object sender, EventArgs e)
    {
      this.Close();
      this.Dispose();
    }

#endregion

#region retreive information
    private void buttonOK_Click(object sender, EventArgs e)
    {
      /*if size of DataIn is smaller than LC, we padd dataIn with 00 */
      if ( (this.LC != "") && (this.LC != "-"))
      {
        int sizeDataIn = (int)System.Convert.ToByte(int.Parse(this.LC,
            System.Globalization.NumberStyles.HexNumber));
        string newDataIn = this.DATAIN.Replace("0x", "").Replace(" ", "");
        if (newDataIn.Length < sizeDataIn * 2)
        {
          for (int cpt = newDataIn.Length; cpt < sizeDataIn * 2; cpt++)
            newDataIn += "0";
        }
        this.DATAIN = newDataIn;
      }
      /* We create an APDUCmd with the information given/entered by user */
      this.RawApdu = this.CLA + this.INS + this.P1 + this.P2 + this.LC +
        this.DATAIN+ this.LE;

      
      parent.SetApdu(RawApdu.Replace("0x","").Replace(" ",""));
      /* The main form will display in the APDU panel and run the APDUCmd  */
      this.Close();
      this.Dispose();
    }
#endregion

#region retreive values from text boxes
    private void textBoxForLe_TextChanged(object sender, EventArgs e)
    {
      LE = textBoxForLe.Text;
    }

    private void textBoxForDataIn_TextChanged(object sender, EventArgs e)
    {
      DATAIN = textBoxForDataIn.Text;
    }

    private void textBoxForLc_TextChanged(object sender, EventArgs e)
    {
      LC = textBoxForLc.Text;
    }

    private void textBoxForP2_TextChanged(object sender, EventArgs e)
    {
      P2 = textBoxForP2.Text;
      string desc_temp = IniReadValue(sectionName, "P2");
      string[] desc_array = desc_temp.Split(limit);
      DescriptionP2.Text = desc_array[0];
      if (DescriptionP2.Text.Length > 0)
        DescriptionP2.Visible = true;
      if (desc_array.Length > 1)
      {
        for (int cpt = 1; cpt < desc_array.Length; cpt++)
        {
          if (desc_array[cpt].StartsWith(P2 + ":"))
          {
            string[] choice_array = desc_array[cpt].Split(desc);
            if (choice_array.Length > 1)
              DescriptionP2.Text += " : " + choice_array[1];
          }
        }
      }
    }

    private void textBoxForP1_TextChanged(object sender, EventArgs e)
    {
      P1 = textBoxForP1.Text;
      string desc_temp = IniReadValue(sectionName, "P1");
      string[] desc_array = desc_temp.Split(limit);
      DescriptionP1.Text = desc_array[0];
      if (DescriptionP1.Text.Length > 0)
        DescriptionP1.Visible = true;
      if (desc_array.Length > 1)
      {
        for (int cpt = 1; cpt < desc_array.Length; cpt++)
        {
          if (desc_array[cpt].StartsWith(P1 + ":"))
          {
            string[] choice_array = desc_array[cpt].Split(desc);
            if (choice_array.Length > 1)
              DescriptionP1.Text += " : " + choice_array[1];
          }
        }
      }
    }

    private void textBoxForIns_TextChanged(object sender, EventArgs e)
    {
      INS = textBoxForIns.Text;
    }

    private void textBoxForCla_TextChanged(object sender, EventArgs e)
    {
      CLA = textBoxForCla.Text;
    }

#endregion

#region data conversion
    private string createStrFromByteArray(byte[] byteArray)
    {
      string Str = "";
      if (byteArray.Length <= 0)
        return Str;
      for (int cpt = 0; cpt < byteArray.Length - 1; cpt++)
        Str += String.Format("{0:X02}", byteArray[cpt]) + " ";
      Str += String.Format("{0:X02}", byteArray[byteArray.Length - 1]);
      return Str;
    }
#endregion

#region read config file
    /* DllImport to get data from ini files */
    [DllImport("kernel32")]
    private static extern int GetPrivateProfileString(string section,
        string key, string def, StringBuilder retVal, int size, string filePath);


    public string IniReadValue(string Section, string Key)
    /* get initialization data from ini file */
    {
      StringBuilder temp = new StringBuilder(500);
      String CurrentDir = Application.StartupPath;
      int i = GetPrivateProfileString(Section, Key, "", temp, 500, CurrentDir + "/apdu_description.cfg");
      return temp.ToString();
    }



#endregion

  }
}