import java.awt.Color;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.LayoutManager;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.security.*;


import javax.smartcardio.*;
import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.JComboBox;

public class applet_pcsc extends JApplet{

	/**
	 */
	private static final long serialVersionUID = 1L;
	JButton butTransmit = new JButton("Transmit");
	JButton butRefresh = new JButton("Refresh");
	JButton butConnect = new JButton("Connect");
	JButton butDisconnect = new JButton("Disconnect");
	JRadioButton T1Protocol = new JRadioButton("T=1",false);
	JRadioButton T0Protocol = new JRadioButton("T=0",false);
	JRadioButton AnyProtocol = new JRadioButton("Any",true);
	JCheckBox Reset = new JCheckBox("Reset",false);
	String Protocol = "*"; 
	JTextField ApduIn;
	JComboBox ReaderList;
	JTextField ApduOut;
	Container Panel;
	LayoutManager Layout;
	CardTerminal WorkingReader;
	JLabel Info;
	public Card card;
	boolean resetWhenDisconnect = false;
	boolean CardIsPresent;
	String CardATR;
	String[] ReadersList;
	int NbReaders;


	/**
	 * Mthode d'initialisation de l'applet
	 * C'est cette mthode qui fait office de constructeur
	 */
	public void init(){
		this.setSize(450, 200);

	    ReaderList = new JComboBox();
	    Layout = new FlowLayout ();
	    Panel = getContentPane ();
	    Info = new JLabel();
	    
	   
				
		//adding click function to the button
		butTransmit.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				TransmitApduToCard();
			}			
		});
		
		butRefresh.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				FillComboBox();
			}			
		});
		

		
		butConnect.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				try {
					card = WorkingReader.connect(Protocol);
					if(card != null)
					{
						butTransmit.setEnabled(true);
						butDisconnect.setEnabled(true);
						Reset.setEnabled(true);
						butConnect.setEnabled(false);
					    T1Protocol.setEnabled(false);
					    T0Protocol.setEnabled(false);
					    AnyProtocol.setEnabled(false);
					    Info.setText(WorkingReader.getName()+" : Card connected");
					}
				} catch (CardException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					try {
						if(WorkingReader.isCardPresent())
							Info.setText("Connect failed. Try using another protocol");
						else
							Info.setText("Put a card on the reader before trying to connect");
					} catch (CardException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
				}
			}			
		});
		
		butDisconnect.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				try {
					card.disconnect(resetWhenDisconnect);
					butTransmit.setEnabled(false);
					butConnect.setEnabled(true);
				    T1Protocol.setEnabled(true);
				    T0Protocol.setEnabled(true);
				    AnyProtocol.setEnabled(true);
				    butDisconnect.setEnabled(false);
				    Reset.setEnabled(false);
				    Info.setText(WorkingReader.getName());
				} catch (CardException e) {
					// TODO Auto-generated catch block
					Info.setText("Disconnect failed.");
					e.printStackTrace();
				}
			}			
		});
		
		T1Protocol.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				/* uncheck other radio buttons */
				AnyProtocol.setSelected(false);
				T0Protocol.setSelected(false);
				/* set new protocol */
				Protocol = "T=1";
			}			
		});
		
		T0Protocol.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				/* uncheck other radio buttons */
				AnyProtocol.setSelected(false);
				T1Protocol.setSelected(false);
				/* set new protocol */
				Protocol = "T=0";
			}			
		});
		
		Reset.addItemListener(new ItemListener(){
			public void itemStateChanged(ItemEvent e) {
				resetWhenDisconnect = ((e.getStateChange() == ItemEvent.SELECTED));
			}
				
		});
		
		AnyProtocol.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				/* uncheck other radio buttons */
				T1Protocol.setSelected(false);
				T0Protocol.setSelected(false);
				/* set new protocol */
				Protocol = "*";
			}			
		});
	    
		ReaderList.addItemListener(new ItemListener(){
			public void itemStateChanged(ItemEvent e) {
				if(ReaderList.getSelectedItem() != null)
				{
					WorkingReader = (CardTerminal) ReaderList.getSelectedItem();
					Info.setText("Selected Reader : "+WorkingReader.getName());
					butConnect.setEnabled(true);
				}
			}			
		});
		

		ApduIn = new JTextField ("", 40);
	    ApduOut = new JTextField ("", 40);

	    ApduOut.setEditable (false);
	    butTransmit.setEnabled(false);
	    butConnect.setEnabled(false);
	    butDisconnect.setEnabled(false);
	    Reset.setEnabled(false);
	    ApduOut.setBackground (Color.lightGray);
	    ReaderList.setEditable(false);
	    Panel.setLayout (Layout);
	    Panel.add(ReaderList);
	    Panel.add(butRefresh);
	    Panel.add(butConnect);
	    Panel.add(T1Protocol);
	    Panel.add(T0Protocol);
	    Panel.add(AnyProtocol);
	    Panel.add(butDisconnect);
	    Panel.add(Reset);
	    Panel.add (ApduIn);
	    Panel.add(butTransmit);
	    Panel.add (ApduOut);
		Info.setHorizontalAlignment(JLabel.CENTER);
		Info.setForeground(Color.blue);
        Panel.add(Info);
	    FillComboBox();

	}
	

	public void FillComboBox()
	{
		/* We fill the comboBox component with the list of the PC/SC readers found */
		CardTerminals terminalList;
		CardTerminal toSelect = WorkingReader;
		TerminalFactory factory = TerminalFactory.getDefault();
	    terminalList = factory.terminals();
	    ReaderList.removeAllItems();
	    try {
	    	for (int i=0;  i < terminalList.list().size(); i++)
			{
               ReaderList.addItem(terminalList.list().get(i)) ; 
			 }
			if(toSelect != null)
				ReaderList.setSelectedItem(toSelect);
 
		} catch (CardException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	
	public void TransmitApduToCard()
	{

		
		try {
			
		    CardChannel comm = card.getBasicChannel();
		    CommandAPDU getData = new CommandAPDU(hexStringToByteArray(ApduIn.getText()));
		    ResponseAPDU resp = comm.transmit(getData);
		    ApduOut.setText(byteArrayToHexString(resp.getBytes()));

		} catch (CardException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	

	
	public boolean IsCardPresent()
	{	
		try {
			AccessController.doPrivileged(new PrivilegedExceptionAction<Boolean>() {
			public Boolean run(){	
			try {			
				CardIsPresent =WorkingReader.isCardPresent();
			} catch (CardException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				Info.setText("Exception "+e.getMessage());
			}
			return true;
				}
				});
		} catch (PrivilegedActionException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	  return CardIsPresent;	
	}
	
	
	
	public String SetReader(String newName)
	{	
		final String NewReaderName = newName;
		try {
			AccessController.doPrivileged(new PrivilegedExceptionAction<Boolean>() {
			public Boolean run(){		
				CardTerminals terminalList;
				TerminalFactory factory = TerminalFactory.getDefault();
			    terminalList = factory.terminals();
				WorkingReader = terminalList.getTerminal(NewReaderName);
         	   FillComboBox();
			return true;
			}
		});
		} catch (PrivilegedActionException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	  return WorkingReader.getName();	
	}
	
	public void Disconnect(boolean reset)
	{	
		final boolean ResetChoice = reset;
		try {
			AccessController.doPrivileged(new PrivilegedExceptionAction<Boolean>() {
			public Boolean run(){		
				try {
					card.disconnect(ResetChoice);
				} catch (CardException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			    Info.setText(WorkingReader.getName());
			return true;
			}
		});
		} catch (PrivilegedActionException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}	
	}
	
	
	String ApduRsp;
	
	public String TransmitString(String ApduIn)
	{	
		final String ApduCmd = ApduIn;
		try {
			AccessController.doPrivileged(new PrivilegedExceptionAction<Boolean>() {
			public Boolean run(){		
				CardChannel comm = card.getBasicChannel();
			    CommandAPDU getData = new CommandAPDU(hexStringToByteArray(ApduCmd));
			    ResponseAPDU resp;
				try {
					resp = comm.transmit(getData);
					 ApduRsp =byteArrayToHexString(resp.getBytes()); 
				} catch (CardException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					ApduRsp = "Exception "+e.getMessage();
				}
			   
			return true;
			}
		});
		} catch (PrivilegedActionException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	  return ApduRsp;	
	}
	

	
	public String TransmitArray(byte[] ApduIn)
	{	
		final byte[] ApduCmd = ApduIn;
		try {
			AccessController.doPrivileged(new PrivilegedExceptionAction<Boolean>() {
			public Boolean run(){		
				CardChannel comm = card.getBasicChannel();
			    CommandAPDU getData = new CommandAPDU(ApduCmd);
			    ResponseAPDU resp;
				try {
					resp = comm.transmit(getData);
					 ApduRsp =byteArrayToHexString(resp.getBytes()); 
				} catch (CardException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					ApduRsp = "Exception "+e.getMessage();
				}
			   
			return true;
			}
		});
		} catch (PrivilegedActionException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	  return ApduRsp;	
	}
	
	
	
	public int GetReaderCount()
	{	
	  NbReaders=0;	
		try {
			AccessController.doPrivileged(new PrivilegedExceptionAction<Boolean>() {
			public Boolean run(){	
			try {			
				CardTerminals terminalList;
				TerminalFactory factory = TerminalFactory.getDefault();
			    terminalList = factory.terminals();
			    NbReaders = terminalList.list().size();
			} catch (CardException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				Info.setText("Exception "+e.getMessage());
			}
			return true;
				}
				});
		} catch (PrivilegedActionException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	  return NbReaders;	
	}
	
	String ReaderName;
	
	public String GetReaderName(int readerIndex)
	{	
		final int Index = readerIndex;
		try {
			AccessController.doPrivileged(new PrivilegedExceptionAction<Boolean>() {
			public Boolean run(){	
			try {			
				CardTerminals terminalList;
				TerminalFactory factory = TerminalFactory.getDefault();
			    terminalList = factory.terminals();
			    ReaderName = terminalList.list().get(Index).getName();
			} catch (CardException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				Info.setText("Exception "+e.getMessage());
				ReaderName = Info.getText();
			}
			return true;
				}
				});
		} catch (PrivilegedActionException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	  return ReaderName;	
	}
	
	public String GetATR()
	{	
		try {
			AccessController.doPrivileged(new PrivilegedExceptionAction<Boolean>() {
			public Boolean run(){	
			try {			
				// establish a connection with the card
	    	    Card card = WorkingReader.connect("*");
	    	    //reset the card
	    	    ATR atr = card.getATR();
	    	    CardATR = byteArrayToHexString(atr.getBytes());
			} catch (CardException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				Info.setText("Exception "+e.getMessage());
				CardATR = Info.getText();
			}
			return true;
				}
				});
		} catch (PrivilegedActionException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	  return CardATR;	
	}
	


	String ConnectResponse ="";
	public String Connect(String protocol){
		final String Protocol_str = protocol;
		// this code allows us to run the code with the Applet security privs
		try {
			AccessController.doPrivileged(new PrivilegedExceptionAction<Integer>() {
			public Integer run(){
				try {
					card = WorkingReader.connect(Protocol_str);
					if(card != null)
					{
						butTransmit.setEnabled(true);
						Info.setText(WorkingReader.getName()+" : card connected");
						ConnectResponse ="";
					}
				} catch (CardException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					try {
						if(WorkingReader.isCardPresent())
							Info.setText("Cannot connect card, try with another protocol");
						else
							Info.setText("Put a card in the reader before connecting");
						ConnectResponse = Info.getText();
					} catch (CardException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
				}
				return null;
			}
			});
		} catch (PrivilegedActionException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	  return ConnectResponse;
	}
	
	
	
	

	static String byteArrayToHexString(byte[] bArray){
		  StringBuffer buffer = new StringBuffer();
		    
		  for(byte b : bArray) {
		  
		      buffer.append(String.format(" %02X" , b));
		  }
		    
		  return buffer.toString().toUpperCase();    
		}
	
	public static byte[] hexStringToByteArray(String s) {
		s = s.replace(" ", "");
	    int len = s.length();
	    byte[] data = new byte[len / 2];
	    for (int i = 0; i < len; i += 2) {
	        data[i / 2] = (byte) ((Character.digit(s.charAt(i), 16) << 4)
	                             + Character.digit(s.charAt(i+1), 16));
	    }
	    return data;
	}

	

	
}
